package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.gfx.*;
import com.danitheskunk.skunkworks.gfx.font.IFont;
import com.danitheskunk.skunkworks.gfx.threedee.IRenderContext3D;

import java.util.List;

public interface IWindow {
	void finishFrame();

	Engine getEngine();

	BaseGamepad getGamepad(int id);

	IMouse getMouse();

	IPipeline<IRenderContext> getPipeline2D();

	IPipeline<IRenderContext3D> getPipeline3D();

	IFont loadFontTTF(String path, float size);

	IFont loadFontTileset(String path);

	NineSlice loadNineSlice(Image image);

	NineSlice loadNineSlice(String path);

	ITexture loadTexture(Image image);

	ITexture loadTexture(String path);

	List<ITexture> loadTextureArray(Image image, Vec2i tileSize);

	List<ITexture> loadTextureArray(String path, Vec2i tileSize);

	//needs to be run after rendering
	void runScaler();

	void setDebug(boolean on);

	void setScaler(String scaler);

	boolean shouldClose();

	void startFrame();

	void tick();
}
