package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.audio.ISample;
import com.danitheskunk.skunkworks.gfx.font.FontTileset;
import com.danitheskunk.skunkworks.nodes.NodeSprite;
import com.danitheskunk.skunkworks.nodes.NodeText;
import org.lwjgl.glfw.GLFW;

public class TestNode extends BaseGame {
	private final ISample kick;
	private final NodeSprite sprite;
	private final NodeText text;
	private final NodeText text2;
	float[] axes;

	public TestNode() {
		super(new Vec2i(1280, 720), "Skunkworks");

		kick = loadSample("demoassets/kick.wav");
		var font = window.loadFontTileset("fonts/ega-8x14.png");
		var font2 = window.loadFontTTF("fonts/LiberationSans-Regular.ttf", 24.0f);
		text = new NodeText(font, "Hello World! this is an extra long test meow meow nya nya! nyaaa!");
		text2 = new NodeText(font2, "Hello World! this is an extra long test meow meow nya nya! nyaaa!");
		text.setMaxSize(new Vec2i(100, 100));
		text2.setMaxSize(new Vec2i(100, 100));
		sprite = new NodeSprite();
		sprite.setTexture(loadTexture("demoassets/card.png"));
		sprite.setPos(new Vec2f(100, 100));
		//rootNode.add(sprite);
		rootNode.add(text);
		rootNode.add(text2);
		//doThing();

	}

	void doThing() {
		sprite.tweenPos(new Vec2f(800, 400), 120).delay(60).then(() -> {
			System.out.println("yay! got there! now lets go home");
			sprite.tweenPos(new Vec2f(100, 100), 120).then(this::doThing);
			playSample(kick);
		});
	}

	@Override
	protected void update(double delta) {
		text.setPos(new Vec2f(640 + 640 * gamepad.getAxis(0), 360 + 360 * gamepad.getAxis(1)));
		text2.setPos(new Vec2f(440 + 640 * gamepad.getAxis(0), 360 + 360 * gamepad.getAxis(1)));
		if(gamepad.getButtonPressed(0)) {
			playSample(kick);
		}
	}

	public static void main(String[] args) {
		new TestNode().run();
	}
}

